// generated from rosidl_generator_cpp/resource/idl__builder.hpp.em
// with input from ds_dbw_msgs:msg/MiscReport.idl
// generated code does not contain a copyright notice

#ifndef DS_DBW_MSGS__MSG__DETAIL__MISC_REPORT__BUILDER_HPP_
#define DS_DBW_MSGS__MSG__DETAIL__MISC_REPORT__BUILDER_HPP_

#include <algorithm>
#include <utility>

#include "ds_dbw_msgs/msg/detail/misc_report__struct.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


namespace ds_dbw_msgs
{

namespace msg
{

namespace builder
{

class Init_MiscReport_outside_air_temp
{
public:
  explicit Init_MiscReport_outside_air_temp(::ds_dbw_msgs::msg::MiscReport & msg)
  : msg_(msg)
  {}
  ::ds_dbw_msgs::msg::MiscReport outside_air_temp(::ds_dbw_msgs::msg::MiscReport::_outside_air_temp_type arg)
  {
    msg_.outside_air_temp = std::move(arg);
    return std::move(msg_);
  }

private:
  ::ds_dbw_msgs::msg::MiscReport msg_;
};

class Init_MiscReport_ambient_light
{
public:
  explicit Init_MiscReport_ambient_light(::ds_dbw_msgs::msg::MiscReport & msg)
  : msg_(msg)
  {}
  Init_MiscReport_outside_air_temp ambient_light(::ds_dbw_msgs::msg::MiscReport::_ambient_light_type arg)
  {
    msg_.ambient_light = std::move(arg);
    return Init_MiscReport_outside_air_temp(msg_);
  }

private:
  ::ds_dbw_msgs::msg::MiscReport msg_;
};

class Init_MiscReport_headlight_high_control
{
public:
  explicit Init_MiscReport_headlight_high_control(::ds_dbw_msgs::msg::MiscReport & msg)
  : msg_(msg)
  {}
  Init_MiscReport_ambient_light headlight_high_control(::ds_dbw_msgs::msg::MiscReport::_headlight_high_control_type arg)
  {
    msg_.headlight_high_control = std::move(arg);
    return Init_MiscReport_ambient_light(msg_);
  }

private:
  ::ds_dbw_msgs::msg::MiscReport msg_;
};

class Init_MiscReport_headlight_low_control
{
public:
  explicit Init_MiscReport_headlight_low_control(::ds_dbw_msgs::msg::MiscReport & msg)
  : msg_(msg)
  {}
  Init_MiscReport_headlight_high_control headlight_low_control(::ds_dbw_msgs::msg::MiscReport::_headlight_low_control_type arg)
  {
    msg_.headlight_low_control = std::move(arg);
    return Init_MiscReport_headlight_high_control(msg_);
  }

private:
  ::ds_dbw_msgs::msg::MiscReport msg_;
};

class Init_MiscReport_headlight_high
{
public:
  explicit Init_MiscReport_headlight_high(::ds_dbw_msgs::msg::MiscReport & msg)
  : msg_(msg)
  {}
  Init_MiscReport_headlight_low_control headlight_high(::ds_dbw_msgs::msg::MiscReport::_headlight_high_type arg)
  {
    msg_.headlight_high = std::move(arg);
    return Init_MiscReport_headlight_low_control(msg_);
  }

private:
  ::ds_dbw_msgs::msg::MiscReport msg_;
};

class Init_MiscReport_headlight_low
{
public:
  explicit Init_MiscReport_headlight_low(::ds_dbw_msgs::msg::MiscReport & msg)
  : msg_(msg)
  {}
  Init_MiscReport_headlight_high headlight_low(::ds_dbw_msgs::msg::MiscReport::_headlight_low_type arg)
  {
    msg_.headlight_low = std::move(arg);
    return Init_MiscReport_headlight_high(msg_);
  }

private:
  ::ds_dbw_msgs::msg::MiscReport msg_;
};

class Init_MiscReport_wiper
{
public:
  explicit Init_MiscReport_wiper(::ds_dbw_msgs::msg::MiscReport & msg)
  : msg_(msg)
  {}
  Init_MiscReport_headlight_low wiper(::ds_dbw_msgs::msg::MiscReport::_wiper_type arg)
  {
    msg_.wiper = std::move(arg);
    return Init_MiscReport_headlight_low(msg_);
  }

private:
  ::ds_dbw_msgs::msg::MiscReport msg_;
};

class Init_MiscReport_btn_call_end
{
public:
  explicit Init_MiscReport_btn_call_end(::ds_dbw_msgs::msg::MiscReport & msg)
  : msg_(msg)
  {}
  Init_MiscReport_wiper btn_call_end(::ds_dbw_msgs::msg::MiscReport::_btn_call_end_type arg)
  {
    msg_.btn_call_end = std::move(arg);
    return Init_MiscReport_wiper(msg_);
  }

private:
  ::ds_dbw_msgs::msg::MiscReport msg_;
};

class Init_MiscReport_btn_call_start
{
public:
  explicit Init_MiscReport_btn_call_start(::ds_dbw_msgs::msg::MiscReport & msg)
  : msg_(msg)
  {}
  Init_MiscReport_btn_call_end btn_call_start(::ds_dbw_msgs::msg::MiscReport::_btn_call_start_type arg)
  {
    msg_.btn_call_start = std::move(arg);
    return Init_MiscReport_btn_call_end(msg_);
  }

private:
  ::ds_dbw_msgs::msg::MiscReport msg_;
};

class Init_MiscReport_btn_next
{
public:
  explicit Init_MiscReport_btn_next(::ds_dbw_msgs::msg::MiscReport & msg)
  : msg_(msg)
  {}
  Init_MiscReport_btn_call_start btn_next(::ds_dbw_msgs::msg::MiscReport::_btn_next_type arg)
  {
    msg_.btn_next = std::move(arg);
    return Init_MiscReport_btn_call_start(msg_);
  }

private:
  ::ds_dbw_msgs::msg::MiscReport msg_;
};

class Init_MiscReport_btn_prev
{
public:
  explicit Init_MiscReport_btn_prev(::ds_dbw_msgs::msg::MiscReport & msg)
  : msg_(msg)
  {}
  Init_MiscReport_btn_next btn_prev(::ds_dbw_msgs::msg::MiscReport::_btn_prev_type arg)
  {
    msg_.btn_prev = std::move(arg);
    return Init_MiscReport_btn_next(msg_);
  }

private:
  ::ds_dbw_msgs::msg::MiscReport msg_;
};

class Init_MiscReport_btn_speak
{
public:
  explicit Init_MiscReport_btn_speak(::ds_dbw_msgs::msg::MiscReport & msg)
  : msg_(msg)
  {}
  Init_MiscReport_btn_prev btn_speak(::ds_dbw_msgs::msg::MiscReport::_btn_speak_type arg)
  {
    msg_.btn_speak = std::move(arg);
    return Init_MiscReport_btn_prev(msg_);
  }

private:
  ::ds_dbw_msgs::msg::MiscReport msg_;
};

class Init_MiscReport_btn_mute
{
public:
  explicit Init_MiscReport_btn_mute(::ds_dbw_msgs::msg::MiscReport & msg)
  : msg_(msg)
  {}
  Init_MiscReport_btn_speak btn_mute(::ds_dbw_msgs::msg::MiscReport::_btn_mute_type arg)
  {
    msg_.btn_mute = std::move(arg);
    return Init_MiscReport_btn_speak(msg_);
  }

private:
  ::ds_dbw_msgs::msg::MiscReport msg_;
};

class Init_MiscReport_btn_vol_dec
{
public:
  explicit Init_MiscReport_btn_vol_dec(::ds_dbw_msgs::msg::MiscReport & msg)
  : msg_(msg)
  {}
  Init_MiscReport_btn_mute btn_vol_dec(::ds_dbw_msgs::msg::MiscReport::_btn_vol_dec_type arg)
  {
    msg_.btn_vol_dec = std::move(arg);
    return Init_MiscReport_btn_mute(msg_);
  }

private:
  ::ds_dbw_msgs::msg::MiscReport msg_;
};

class Init_MiscReport_btn_vol_inc
{
public:
  explicit Init_MiscReport_btn_vol_inc(::ds_dbw_msgs::msg::MiscReport & msg)
  : msg_(msg)
  {}
  Init_MiscReport_btn_vol_dec btn_vol_inc(::ds_dbw_msgs::msg::MiscReport::_btn_vol_inc_type arg)
  {
    msg_.btn_vol_inc = std::move(arg);
    return Init_MiscReport_btn_vol_dec(msg_);
  }

private:
  ::ds_dbw_msgs::msg::MiscReport msg_;
};

class Init_MiscReport_btn_media
{
public:
  explicit Init_MiscReport_btn_media(::ds_dbw_msgs::msg::MiscReport & msg)
  : msg_(msg)
  {}
  Init_MiscReport_btn_vol_inc btn_media(::ds_dbw_msgs::msg::MiscReport::_btn_media_type arg)
  {
    msg_.btn_media = std::move(arg);
    return Init_MiscReport_btn_vol_inc(msg_);
  }

private:
  ::ds_dbw_msgs::msg::MiscReport msg_;
};

class Init_MiscReport_btn_apa
{
public:
  explicit Init_MiscReport_btn_apa(::ds_dbw_msgs::msg::MiscReport & msg)
  : msg_(msg)
  {}
  Init_MiscReport_btn_media btn_apa(::ds_dbw_msgs::msg::MiscReport::_btn_apa_type arg)
  {
    msg_.btn_apa = std::move(arg);
    return Init_MiscReport_btn_media(msg_);
  }

private:
  ::ds_dbw_msgs::msg::MiscReport msg_;
};

class Init_MiscReport_btn_la_on_off
{
public:
  explicit Init_MiscReport_btn_la_on_off(::ds_dbw_msgs::msg::MiscReport & msg)
  : msg_(msg)
  {}
  Init_MiscReport_btn_apa btn_la_on_off(::ds_dbw_msgs::msg::MiscReport::_btn_la_on_off_type arg)
  {
    msg_.btn_la_on_off = std::move(arg);
    return Init_MiscReport_btn_apa(msg_);
  }

private:
  ::ds_dbw_msgs::msg::MiscReport msg_;
};

class Init_MiscReport_btn_limit_on_off
{
public:
  explicit Init_MiscReport_btn_limit_on_off(::ds_dbw_msgs::msg::MiscReport & msg)
  : msg_(msg)
  {}
  Init_MiscReport_btn_la_on_off btn_limit_on_off(::ds_dbw_msgs::msg::MiscReport::_btn_limit_on_off_type arg)
  {
    msg_.btn_limit_on_off = std::move(arg);
    return Init_MiscReport_btn_la_on_off(msg_);
  }

private:
  ::ds_dbw_msgs::msg::MiscReport msg_;
};

class Init_MiscReport_btn_acc_gap_dec
{
public:
  explicit Init_MiscReport_btn_acc_gap_dec(::ds_dbw_msgs::msg::MiscReport & msg)
  : msg_(msg)
  {}
  Init_MiscReport_btn_limit_on_off btn_acc_gap_dec(::ds_dbw_msgs::msg::MiscReport::_btn_acc_gap_dec_type arg)
  {
    msg_.btn_acc_gap_dec = std::move(arg);
    return Init_MiscReport_btn_limit_on_off(msg_);
  }

private:
  ::ds_dbw_msgs::msg::MiscReport msg_;
};

class Init_MiscReport_btn_acc_gap_inc
{
public:
  explicit Init_MiscReport_btn_acc_gap_inc(::ds_dbw_msgs::msg::MiscReport & msg)
  : msg_(msg)
  {}
  Init_MiscReport_btn_acc_gap_dec btn_acc_gap_inc(::ds_dbw_msgs::msg::MiscReport::_btn_acc_gap_inc_type arg)
  {
    msg_.btn_acc_gap_inc = std::move(arg);
    return Init_MiscReport_btn_acc_gap_dec(msg_);
  }

private:
  ::ds_dbw_msgs::msg::MiscReport msg_;
};

class Init_MiscReport_btn_cc_set_dec
{
public:
  explicit Init_MiscReport_btn_cc_set_dec(::ds_dbw_msgs::msg::MiscReport & msg)
  : msg_(msg)
  {}
  Init_MiscReport_btn_acc_gap_inc btn_cc_set_dec(::ds_dbw_msgs::msg::MiscReport::_btn_cc_set_dec_type arg)
  {
    msg_.btn_cc_set_dec = std::move(arg);
    return Init_MiscReport_btn_acc_gap_inc(msg_);
  }

private:
  ::ds_dbw_msgs::msg::MiscReport msg_;
};

class Init_MiscReport_btn_cc_set_inc
{
public:
  explicit Init_MiscReport_btn_cc_set_inc(::ds_dbw_msgs::msg::MiscReport & msg)
  : msg_(msg)
  {}
  Init_MiscReport_btn_cc_set_dec btn_cc_set_inc(::ds_dbw_msgs::msg::MiscReport::_btn_cc_set_inc_type arg)
  {
    msg_.btn_cc_set_inc = std::move(arg);
    return Init_MiscReport_btn_cc_set_dec(msg_);
  }

private:
  ::ds_dbw_msgs::msg::MiscReport msg_;
};

class Init_MiscReport_btn_cc_res_dec
{
public:
  explicit Init_MiscReport_btn_cc_res_dec(::ds_dbw_msgs::msg::MiscReport & msg)
  : msg_(msg)
  {}
  Init_MiscReport_btn_cc_set_inc btn_cc_res_dec(::ds_dbw_msgs::msg::MiscReport::_btn_cc_res_dec_type arg)
  {
    msg_.btn_cc_res_dec = std::move(arg);
    return Init_MiscReport_btn_cc_set_inc(msg_);
  }

private:
  ::ds_dbw_msgs::msg::MiscReport msg_;
};

class Init_MiscReport_btn_cc_res_inc
{
public:
  explicit Init_MiscReport_btn_cc_res_inc(::ds_dbw_msgs::msg::MiscReport & msg)
  : msg_(msg)
  {}
  Init_MiscReport_btn_cc_res_dec btn_cc_res_inc(::ds_dbw_msgs::msg::MiscReport::_btn_cc_res_inc_type arg)
  {
    msg_.btn_cc_res_inc = std::move(arg);
    return Init_MiscReport_btn_cc_res_dec(msg_);
  }

private:
  ::ds_dbw_msgs::msg::MiscReport msg_;
};

class Init_MiscReport_btn_cc_res_cncl
{
public:
  explicit Init_MiscReport_btn_cc_res_cncl(::ds_dbw_msgs::msg::MiscReport & msg)
  : msg_(msg)
  {}
  Init_MiscReport_btn_cc_res_inc btn_cc_res_cncl(::ds_dbw_msgs::msg::MiscReport::_btn_cc_res_cncl_type arg)
  {
    msg_.btn_cc_res_cncl = std::move(arg);
    return Init_MiscReport_btn_cc_res_inc(msg_);
  }

private:
  ::ds_dbw_msgs::msg::MiscReport msg_;
};

class Init_MiscReport_btn_cc_on_off
{
public:
  explicit Init_MiscReport_btn_cc_on_off(::ds_dbw_msgs::msg::MiscReport & msg)
  : msg_(msg)
  {}
  Init_MiscReport_btn_cc_res_cncl btn_cc_on_off(::ds_dbw_msgs::msg::MiscReport::_btn_cc_on_off_type arg)
  {
    msg_.btn_cc_on_off = std::move(arg);
    return Init_MiscReport_btn_cc_res_cncl(msg_);
  }

private:
  ::ds_dbw_msgs::msg::MiscReport msg_;
};

class Init_MiscReport_btn_cc_cncl
{
public:
  explicit Init_MiscReport_btn_cc_cncl(::ds_dbw_msgs::msg::MiscReport & msg)
  : msg_(msg)
  {}
  Init_MiscReport_btn_cc_on_off btn_cc_cncl(::ds_dbw_msgs::msg::MiscReport::_btn_cc_cncl_type arg)
  {
    msg_.btn_cc_cncl = std::move(arg);
    return Init_MiscReport_btn_cc_on_off(msg_);
  }

private:
  ::ds_dbw_msgs::msg::MiscReport msg_;
};

class Init_MiscReport_btn_cc_res
{
public:
  explicit Init_MiscReport_btn_cc_res(::ds_dbw_msgs::msg::MiscReport & msg)
  : msg_(msg)
  {}
  Init_MiscReport_btn_cc_cncl btn_cc_res(::ds_dbw_msgs::msg::MiscReport::_btn_cc_res_type arg)
  {
    msg_.btn_cc_res = std::move(arg);
    return Init_MiscReport_btn_cc_cncl(msg_);
  }

private:
  ::ds_dbw_msgs::msg::MiscReport msg_;
};

class Init_MiscReport_btn_cc_off
{
public:
  explicit Init_MiscReport_btn_cc_off(::ds_dbw_msgs::msg::MiscReport & msg)
  : msg_(msg)
  {}
  Init_MiscReport_btn_cc_res btn_cc_off(::ds_dbw_msgs::msg::MiscReport::_btn_cc_off_type arg)
  {
    msg_.btn_cc_off = std::move(arg);
    return Init_MiscReport_btn_cc_res(msg_);
  }

private:
  ::ds_dbw_msgs::msg::MiscReport msg_;
};

class Init_MiscReport_btn_cc_on
{
public:
  explicit Init_MiscReport_btn_cc_on(::ds_dbw_msgs::msg::MiscReport & msg)
  : msg_(msg)
  {}
  Init_MiscReport_btn_cc_off btn_cc_on(::ds_dbw_msgs::msg::MiscReport::_btn_cc_on_type arg)
  {
    msg_.btn_cc_on = std::move(arg);
    return Init_MiscReport_btn_cc_off(msg_);
  }

private:
  ::ds_dbw_msgs::msg::MiscReport msg_;
};

class Init_MiscReport_btn_cc_mode
{
public:
  explicit Init_MiscReport_btn_cc_mode(::ds_dbw_msgs::msg::MiscReport & msg)
  : msg_(msg)
  {}
  Init_MiscReport_btn_cc_on btn_cc_mode(::ds_dbw_msgs::msg::MiscReport::_btn_cc_mode_type arg)
  {
    msg_.btn_cc_mode = std::move(arg);
    return Init_MiscReport_btn_cc_on(msg_);
  }

private:
  ::ds_dbw_msgs::msg::MiscReport msg_;
};

class Init_MiscReport_btn_rd_right
{
public:
  explicit Init_MiscReport_btn_rd_right(::ds_dbw_msgs::msg::MiscReport & msg)
  : msg_(msg)
  {}
  Init_MiscReport_btn_cc_mode btn_rd_right(::ds_dbw_msgs::msg::MiscReport::_btn_rd_right_type arg)
  {
    msg_.btn_rd_right = std::move(arg);
    return Init_MiscReport_btn_cc_mode(msg_);
  }

private:
  ::ds_dbw_msgs::msg::MiscReport msg_;
};

class Init_MiscReport_btn_rd_left
{
public:
  explicit Init_MiscReport_btn_rd_left(::ds_dbw_msgs::msg::MiscReport & msg)
  : msg_(msg)
  {}
  Init_MiscReport_btn_rd_right btn_rd_left(::ds_dbw_msgs::msg::MiscReport::_btn_rd_left_type arg)
  {
    msg_.btn_rd_left = std::move(arg);
    return Init_MiscReport_btn_rd_right(msg_);
  }

private:
  ::ds_dbw_msgs::msg::MiscReport msg_;
};

class Init_MiscReport_btn_rd_down
{
public:
  explicit Init_MiscReport_btn_rd_down(::ds_dbw_msgs::msg::MiscReport & msg)
  : msg_(msg)
  {}
  Init_MiscReport_btn_rd_left btn_rd_down(::ds_dbw_msgs::msg::MiscReport::_btn_rd_down_type arg)
  {
    msg_.btn_rd_down = std::move(arg);
    return Init_MiscReport_btn_rd_left(msg_);
  }

private:
  ::ds_dbw_msgs::msg::MiscReport msg_;
};

class Init_MiscReport_btn_rd_up
{
public:
  explicit Init_MiscReport_btn_rd_up(::ds_dbw_msgs::msg::MiscReport & msg)
  : msg_(msg)
  {}
  Init_MiscReport_btn_rd_down btn_rd_up(::ds_dbw_msgs::msg::MiscReport::_btn_rd_up_type arg)
  {
    msg_.btn_rd_up = std::move(arg);
    return Init_MiscReport_btn_rd_down(msg_);
  }

private:
  ::ds_dbw_msgs::msg::MiscReport msg_;
};

class Init_MiscReport_btn_rd_ok
{
public:
  explicit Init_MiscReport_btn_rd_ok(::ds_dbw_msgs::msg::MiscReport & msg)
  : msg_(msg)
  {}
  Init_MiscReport_btn_rd_up btn_rd_ok(::ds_dbw_msgs::msg::MiscReport::_btn_rd_ok_type arg)
  {
    msg_.btn_rd_ok = std::move(arg);
    return Init_MiscReport_btn_rd_up(msg_);
  }

private:
  ::ds_dbw_msgs::msg::MiscReport msg_;
};

class Init_MiscReport_btn_ld_right
{
public:
  explicit Init_MiscReport_btn_ld_right(::ds_dbw_msgs::msg::MiscReport & msg)
  : msg_(msg)
  {}
  Init_MiscReport_btn_rd_ok btn_ld_right(::ds_dbw_msgs::msg::MiscReport::_btn_ld_right_type arg)
  {
    msg_.btn_ld_right = std::move(arg);
    return Init_MiscReport_btn_rd_ok(msg_);
  }

private:
  ::ds_dbw_msgs::msg::MiscReport msg_;
};

class Init_MiscReport_btn_ld_left
{
public:
  explicit Init_MiscReport_btn_ld_left(::ds_dbw_msgs::msg::MiscReport & msg)
  : msg_(msg)
  {}
  Init_MiscReport_btn_ld_right btn_ld_left(::ds_dbw_msgs::msg::MiscReport::_btn_ld_left_type arg)
  {
    msg_.btn_ld_left = std::move(arg);
    return Init_MiscReport_btn_ld_right(msg_);
  }

private:
  ::ds_dbw_msgs::msg::MiscReport msg_;
};

class Init_MiscReport_btn_ld_down
{
public:
  explicit Init_MiscReport_btn_ld_down(::ds_dbw_msgs::msg::MiscReport & msg)
  : msg_(msg)
  {}
  Init_MiscReport_btn_ld_left btn_ld_down(::ds_dbw_msgs::msg::MiscReport::_btn_ld_down_type arg)
  {
    msg_.btn_ld_down = std::move(arg);
    return Init_MiscReport_btn_ld_left(msg_);
  }

private:
  ::ds_dbw_msgs::msg::MiscReport msg_;
};

class Init_MiscReport_btn_ld_up
{
public:
  explicit Init_MiscReport_btn_ld_up(::ds_dbw_msgs::msg::MiscReport & msg)
  : msg_(msg)
  {}
  Init_MiscReport_btn_ld_down btn_ld_up(::ds_dbw_msgs::msg::MiscReport::_btn_ld_up_type arg)
  {
    msg_.btn_ld_up = std::move(arg);
    return Init_MiscReport_btn_ld_down(msg_);
  }

private:
  ::ds_dbw_msgs::msg::MiscReport msg_;
};

class Init_MiscReport_btn_ld_ok
{
public:
  explicit Init_MiscReport_btn_ld_ok(::ds_dbw_msgs::msg::MiscReport & msg)
  : msg_(msg)
  {}
  Init_MiscReport_btn_ld_up btn_ld_ok(::ds_dbw_msgs::msg::MiscReport::_btn_ld_ok_type arg)
  {
    msg_.btn_ld_ok = std::move(arg);
    return Init_MiscReport_btn_ld_up(msg_);
  }

private:
  ::ds_dbw_msgs::msg::MiscReport msg_;
};

class Init_MiscReport_door_trunk
{
public:
  explicit Init_MiscReport_door_trunk(::ds_dbw_msgs::msg::MiscReport & msg)
  : msg_(msg)
  {}
  Init_MiscReport_btn_ld_ok door_trunk(::ds_dbw_msgs::msg::MiscReport::_door_trunk_type arg)
  {
    msg_.door_trunk = std::move(arg);
    return Init_MiscReport_btn_ld_ok(msg_);
  }

private:
  ::ds_dbw_msgs::msg::MiscReport msg_;
};

class Init_MiscReport_door_hood
{
public:
  explicit Init_MiscReport_door_hood(::ds_dbw_msgs::msg::MiscReport & msg)
  : msg_(msg)
  {}
  Init_MiscReport_door_trunk door_hood(::ds_dbw_msgs::msg::MiscReport::_door_hood_type arg)
  {
    msg_.door_hood = std::move(arg);
    return Init_MiscReport_door_trunk(msg_);
  }

private:
  ::ds_dbw_msgs::msg::MiscReport msg_;
};

class Init_MiscReport_door_rear_right
{
public:
  explicit Init_MiscReport_door_rear_right(::ds_dbw_msgs::msg::MiscReport & msg)
  : msg_(msg)
  {}
  Init_MiscReport_door_hood door_rear_right(::ds_dbw_msgs::msg::MiscReport::_door_rear_right_type arg)
  {
    msg_.door_rear_right = std::move(arg);
    return Init_MiscReport_door_hood(msg_);
  }

private:
  ::ds_dbw_msgs::msg::MiscReport msg_;
};

class Init_MiscReport_door_rear_left
{
public:
  explicit Init_MiscReport_door_rear_left(::ds_dbw_msgs::msg::MiscReport & msg)
  : msg_(msg)
  {}
  Init_MiscReport_door_rear_right door_rear_left(::ds_dbw_msgs::msg::MiscReport::_door_rear_left_type arg)
  {
    msg_.door_rear_left = std::move(arg);
    return Init_MiscReport_door_rear_right(msg_);
  }

private:
  ::ds_dbw_msgs::msg::MiscReport msg_;
};

class Init_MiscReport_door_passenger
{
public:
  explicit Init_MiscReport_door_passenger(::ds_dbw_msgs::msg::MiscReport & msg)
  : msg_(msg)
  {}
  Init_MiscReport_door_rear_left door_passenger(::ds_dbw_msgs::msg::MiscReport::_door_passenger_type arg)
  {
    msg_.door_passenger = std::move(arg);
    return Init_MiscReport_door_rear_left(msg_);
  }

private:
  ::ds_dbw_msgs::msg::MiscReport msg_;
};

class Init_MiscReport_door_driver
{
public:
  explicit Init_MiscReport_door_driver(::ds_dbw_msgs::msg::MiscReport & msg)
  : msg_(msg)
  {}
  Init_MiscReport_door_passenger door_driver(::ds_dbw_msgs::msg::MiscReport::_door_driver_type arg)
  {
    msg_.door_driver = std::move(arg);
    return Init_MiscReport_door_passenger(msg_);
  }

private:
  ::ds_dbw_msgs::msg::MiscReport msg_;
};

class Init_MiscReport_buckle_passenger
{
public:
  explicit Init_MiscReport_buckle_passenger(::ds_dbw_msgs::msg::MiscReport & msg)
  : msg_(msg)
  {}
  Init_MiscReport_door_driver buckle_passenger(::ds_dbw_msgs::msg::MiscReport::_buckle_passenger_type arg)
  {
    msg_.buckle_passenger = std::move(arg);
    return Init_MiscReport_door_driver(msg_);
  }

private:
  ::ds_dbw_msgs::msg::MiscReport msg_;
};

class Init_MiscReport_buckle_driver
{
public:
  explicit Init_MiscReport_buckle_driver(::ds_dbw_msgs::msg::MiscReport & msg)
  : msg_(msg)
  {}
  Init_MiscReport_buckle_passenger buckle_driver(::ds_dbw_msgs::msg::MiscReport::_buckle_driver_type arg)
  {
    msg_.buckle_driver = std::move(arg);
    return Init_MiscReport_buckle_passenger(msg_);
  }

private:
  ::ds_dbw_msgs::msg::MiscReport msg_;
};

class Init_MiscReport_passenger_airbag
{
public:
  explicit Init_MiscReport_passenger_airbag(::ds_dbw_msgs::msg::MiscReport & msg)
  : msg_(msg)
  {}
  Init_MiscReport_buckle_driver passenger_airbag(::ds_dbw_msgs::msg::MiscReport::_passenger_airbag_type arg)
  {
    msg_.passenger_airbag = std::move(arg);
    return Init_MiscReport_buckle_driver(msg_);
  }

private:
  ::ds_dbw_msgs::msg::MiscReport msg_;
};

class Init_MiscReport_passenger_detect
{
public:
  explicit Init_MiscReport_passenger_detect(::ds_dbw_msgs::msg::MiscReport & msg)
  : msg_(msg)
  {}
  Init_MiscReport_passenger_airbag passenger_detect(::ds_dbw_msgs::msg::MiscReport::_passenger_detect_type arg)
  {
    msg_.passenger_detect = std::move(arg);
    return Init_MiscReport_passenger_airbag(msg_);
  }

private:
  ::ds_dbw_msgs::msg::MiscReport msg_;
};

class Init_MiscReport_parking_brake
{
public:
  explicit Init_MiscReport_parking_brake(::ds_dbw_msgs::msg::MiscReport & msg)
  : msg_(msg)
  {}
  Init_MiscReport_passenger_detect parking_brake(::ds_dbw_msgs::msg::MiscReport::_parking_brake_type arg)
  {
    msg_.parking_brake = std::move(arg);
    return Init_MiscReport_passenger_detect(msg_);
  }

private:
  ::ds_dbw_msgs::msg::MiscReport msg_;
};

class Init_MiscReport_header
{
public:
  Init_MiscReport_header()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_MiscReport_parking_brake header(::ds_dbw_msgs::msg::MiscReport::_header_type arg)
  {
    msg_.header = std::move(arg);
    return Init_MiscReport_parking_brake(msg_);
  }

private:
  ::ds_dbw_msgs::msg::MiscReport msg_;
};

}  // namespace builder

}  // namespace msg

template<typename MessageType>
auto build();

template<>
inline
auto build<::ds_dbw_msgs::msg::MiscReport>()
{
  return ds_dbw_msgs::msg::builder::Init_MiscReport_header();
}

}  // namespace ds_dbw_msgs

#endif  // DS_DBW_MSGS__MSG__DETAIL__MISC_REPORT__BUILDER_HPP_
