// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from ds_dbw_msgs:msg/DriverAssist.idl
// generated code does not contain a copyright notice

#ifndef DS_DBW_MSGS__MSG__DETAIL__DRIVER_ASSIST__TRAITS_HPP_
#define DS_DBW_MSGS__MSG__DETAIL__DRIVER_ASSIST__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "ds_dbw_msgs/msg/detail/driver_assist__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'decel_src'
#include "ds_dbw_msgs/msg/detail/decel_src__traits.hpp"

namespace ds_dbw_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const DriverAssist & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: decel
  {
    out << "decel: ";
    rosidl_generator_traits::value_to_yaml(msg.decel, out);
    out << ", ";
  }

  // member: decel_src
  {
    out << "decel_src: ";
    to_flow_style_yaml(msg.decel_src, out);
    out << ", ";
  }

  // member: fcw_active
  {
    out << "fcw_active: ";
    rosidl_generator_traits::value_to_yaml(msg.fcw_active, out);
    out << ", ";
  }

  // member: fcw_enabled
  {
    out << "fcw_enabled: ";
    rosidl_generator_traits::value_to_yaml(msg.fcw_enabled, out);
    out << ", ";
  }

  // member: aeb_active
  {
    out << "aeb_active: ";
    rosidl_generator_traits::value_to_yaml(msg.aeb_active, out);
    out << ", ";
  }

  // member: aeb_precharge
  {
    out << "aeb_precharge: ";
    rosidl_generator_traits::value_to_yaml(msg.aeb_precharge, out);
    out << ", ";
  }

  // member: aeb_enabled
  {
    out << "aeb_enabled: ";
    rosidl_generator_traits::value_to_yaml(msg.aeb_enabled, out);
    out << ", ";
  }

  // member: acc_braking
  {
    out << "acc_braking: ";
    rosidl_generator_traits::value_to_yaml(msg.acc_braking, out);
    out << ", ";
  }

  // member: acc_enabled
  {
    out << "acc_enabled: ";
    rosidl_generator_traits::value_to_yaml(msg.acc_enabled, out);
    out << ", ";
  }

  // member: blis_l_alert
  {
    out << "blis_l_alert: ";
    rosidl_generator_traits::value_to_yaml(msg.blis_l_alert, out);
    out << ", ";
  }

  // member: blis_l_enabled
  {
    out << "blis_l_enabled: ";
    rosidl_generator_traits::value_to_yaml(msg.blis_l_enabled, out);
    out << ", ";
  }

  // member: blis_r_alert
  {
    out << "blis_r_alert: ";
    rosidl_generator_traits::value_to_yaml(msg.blis_r_alert, out);
    out << ", ";
  }

  // member: blis_r_enabled
  {
    out << "blis_r_enabled: ";
    rosidl_generator_traits::value_to_yaml(msg.blis_r_enabled, out);
    out << ", ";
  }

  // member: cta_l_alert
  {
    out << "cta_l_alert: ";
    rosidl_generator_traits::value_to_yaml(msg.cta_l_alert, out);
    out << ", ";
  }

  // member: cta_l_enabled
  {
    out << "cta_l_enabled: ";
    rosidl_generator_traits::value_to_yaml(msg.cta_l_enabled, out);
    out << ", ";
  }

  // member: cta_r_alert
  {
    out << "cta_r_alert: ";
    rosidl_generator_traits::value_to_yaml(msg.cta_r_alert, out);
    out << ", ";
  }

  // member: cta_r_enabled
  {
    out << "cta_r_enabled: ";
    rosidl_generator_traits::value_to_yaml(msg.cta_r_enabled, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const DriverAssist & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: decel
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "decel: ";
    rosidl_generator_traits::value_to_yaml(msg.decel, out);
    out << "\n";
  }

  // member: decel_src
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "decel_src:\n";
    to_block_style_yaml(msg.decel_src, out, indentation + 2);
  }

  // member: fcw_active
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "fcw_active: ";
    rosidl_generator_traits::value_to_yaml(msg.fcw_active, out);
    out << "\n";
  }

  // member: fcw_enabled
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "fcw_enabled: ";
    rosidl_generator_traits::value_to_yaml(msg.fcw_enabled, out);
    out << "\n";
  }

  // member: aeb_active
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "aeb_active: ";
    rosidl_generator_traits::value_to_yaml(msg.aeb_active, out);
    out << "\n";
  }

  // member: aeb_precharge
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "aeb_precharge: ";
    rosidl_generator_traits::value_to_yaml(msg.aeb_precharge, out);
    out << "\n";
  }

  // member: aeb_enabled
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "aeb_enabled: ";
    rosidl_generator_traits::value_to_yaml(msg.aeb_enabled, out);
    out << "\n";
  }

  // member: acc_braking
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "acc_braking: ";
    rosidl_generator_traits::value_to_yaml(msg.acc_braking, out);
    out << "\n";
  }

  // member: acc_enabled
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "acc_enabled: ";
    rosidl_generator_traits::value_to_yaml(msg.acc_enabled, out);
    out << "\n";
  }

  // member: blis_l_alert
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "blis_l_alert: ";
    rosidl_generator_traits::value_to_yaml(msg.blis_l_alert, out);
    out << "\n";
  }

  // member: blis_l_enabled
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "blis_l_enabled: ";
    rosidl_generator_traits::value_to_yaml(msg.blis_l_enabled, out);
    out << "\n";
  }

  // member: blis_r_alert
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "blis_r_alert: ";
    rosidl_generator_traits::value_to_yaml(msg.blis_r_alert, out);
    out << "\n";
  }

  // member: blis_r_enabled
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "blis_r_enabled: ";
    rosidl_generator_traits::value_to_yaml(msg.blis_r_enabled, out);
    out << "\n";
  }

  // member: cta_l_alert
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "cta_l_alert: ";
    rosidl_generator_traits::value_to_yaml(msg.cta_l_alert, out);
    out << "\n";
  }

  // member: cta_l_enabled
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "cta_l_enabled: ";
    rosidl_generator_traits::value_to_yaml(msg.cta_l_enabled, out);
    out << "\n";
  }

  // member: cta_r_alert
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "cta_r_alert: ";
    rosidl_generator_traits::value_to_yaml(msg.cta_r_alert, out);
    out << "\n";
  }

  // member: cta_r_enabled
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "cta_r_enabled: ";
    rosidl_generator_traits::value_to_yaml(msg.cta_r_enabled, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const DriverAssist & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace ds_dbw_msgs

namespace rosidl_generator_traits
{

[[deprecated("use ds_dbw_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const ds_dbw_msgs::msg::DriverAssist & msg,
  std::ostream & out, size_t indentation = 0)
{
  ds_dbw_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use ds_dbw_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const ds_dbw_msgs::msg::DriverAssist & msg)
{
  return ds_dbw_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<ds_dbw_msgs::msg::DriverAssist>()
{
  return "ds_dbw_msgs::msg::DriverAssist";
}

template<>
inline const char * name<ds_dbw_msgs::msg::DriverAssist>()
{
  return "ds_dbw_msgs/msg/DriverAssist";
}

template<>
struct has_fixed_size<ds_dbw_msgs::msg::DriverAssist>
  : std::integral_constant<bool, has_fixed_size<ds_dbw_msgs::msg::DecelSrc>::value && has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<ds_dbw_msgs::msg::DriverAssist>
  : std::integral_constant<bool, has_bounded_size<ds_dbw_msgs::msg::DecelSrc>::value && has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<ds_dbw_msgs::msg::DriverAssist>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // DS_DBW_MSGS__MSG__DETAIL__DRIVER_ASSIST__TRAITS_HPP_
